META
{
  Parser = Game;
  Engine = G2, G2A;
};
// global instance of the first and second player
extern INSTANCE hero(C_NPC);
extern INSTANCE hero_2(C_NPC);


/************************************************************************************/
/*** 						Enemy Targeting									  	  ***/
/************************************************************************************/

//CHOOSE BETWEEN: 
//-"ALWAYS TARGET PLAYER WITH LESS HP WHEN PLAYERS ARE WITHIN A DISTANCE OF 10 METERS"
//-"TARGET PLAYER WHO LAST HIT ENEMY", "TARGET PLAYER AFTER RANDOM ENEMY HITS"
//-"TARGET PLAYER WHO FIRST HIT ENEMY" 
//by removing the /* and */ that surround the option with the function and by adding it to the other options

//"ALWAYS TARGET PLAYER WITH LESS HP WHEN PLAYERS ARE WITHIN A DISTANCE OF 10 METERS" Hooks
/*
func void B_AssessEnemy ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) < 1000)
		{
			if (hero_2.attribute[ATR_HITPOINTS] < hero.attribute[ATR_HITPOINTS])
			{
				other = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
			}else if (hero_2.attribute[ATR_HITPOINTS] > hero.attribute[ATR_HITPOINTS])
			{
				other = Cast_PointerToInstance(Cast_InstanceToPointer(hero));
			};
		};
	};
	B_AssessEnemy_old();
};
func void B_MM_AssessEnemy ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) < 1000)
		{
			if (hero_2.attribute[ATR_HITPOINTS] < hero.attribute[ATR_HITPOINTS])
			{
				other = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
			}else if (hero_2.attribute[ATR_HITPOINTS] > hero.attribute[ATR_HITPOINTS])
			{
				other = Cast_PointerToInstance(Cast_InstanceToPointer(hero));
			};
		};
	};
	B_MM_AssessEnemy_old();
};

func int ZS_MM_Attack_Loop ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) < 1000)
		{
			if (hero_2.attribute[ATR_HITPOINTS] < hero.attribute[ATR_HITPOINTS])
			{
				Npc_SetTarget(self, hero_2);
			}else if (hero_2.attribute[ATR_HITPOINTS] > hero.attribute[ATR_HITPOINTS])
			{
				Npc_SetTarget(self, hero);
			};
		};
	};
	return ZS_MM_Attack_Loop_old();
};

func int ZS_Attack_Loop ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) < 1000)
		{
			if (hero_2.attribute[ATR_HITPOINTS] < hero.attribute[ATR_HITPOINTS])
			{
				Npc_SetTarget(self, hero_2);
			}else if (hero_2.attribute[ATR_HITPOINTS] > hero.attribute[ATR_HITPOINTS])
			{
				Npc_SetTarget(self, hero);
			};
		};
	};
	return ZS_Attack_Loop_old();
};


func void B_AssessDamage ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) > 1000)
		{
			Npc_SetTarget(self, other);
		};
	};
	B_AssessDamage_old();
};

func void B_MM_AssessDamage ()
{
	if (Cast_InstanceToPointer(hero_2) == Cast_InstanceToPointer(other) || Cast_InstanceToPointer(hero) == Cast_InstanceToPointer(other)){
		if (Npc_GetDistToNpc(hero, hero_2) > 1000)
		{
			Npc_SetTarget(self, other);
		};
	};
	B_MM_AssessDamage_old();
};
*/

//"TARGET PLAYER WHO LAST HIT ENEMY" Hooks

/*
func void B_AssessDamage ()
{
	if (Npc_IsInState(self,ZS_Attack))
	{
		if (Hlp_GetInstanceID (hero_2) == self.aivar[AIV_LASTTARGET])
		{
			Npc_SetTarget (self, other);
		};
	};
	B_AssessDamage_old();
};

func void B_MM_AssessDamage ()
{
	if (Npc_IsInState(self,ZS_MM_Attack))
	{
		if (Hlp_GetInstanceID (hero_2) == self.aivar[AIV_LASTTARGET]){
			Npc_SetTarget (self, other);
		};
	};
	B_MM_AssessDamage_old();
};
*/

//"TARGET PLAYER AFTER RANDOM ENEMY HITS" Hooks


func void B_AssessDamage ()
{
	if (Npc_IsInState(self,ZS_Attack))
	{
		if (Hlp_GetInstanceID (hero_2) == self.aivar[AIV_LASTTARGET])
		{
			if (Hlp_Random(11) > 5){
				Npc_SetTarget (self, other);
			};
		};
	};
	B_AssessDamage_old();
};

func void B_MM_AssessDamage ()
{
	if (Npc_IsInState(self,ZS_MM_Attack))
	{
		if (Hlp_GetInstanceID (hero_2) == self.aivar[AIV_LASTTARGET]){
			if (Hlp_Random(11) > 5){
				Npc_SetTarget (self, other);
			};
		};
	};
	B_MM_AssessDamage_old();
};


//"TARGET PLAYER WHO FIRST HIT ENEMY" Hooks

/*
//Standard option which doesn't need any hooks
*/

/************************************************************************************/
/*** 						XP-Share									  	 	  ***/
/************************************************************************************/

//CHOOSE BETWEEN:
//-"XP-Share"
//-"Half XP-Share"
//-"Each player gets his own XP" 
//by removing the /* and */ that surround the option with the function and by adding it to the other options

//"XP-Share"-Hooks

func void B_GivePlayerXP (var int add_xp)
{
	
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	B_GivePlayerXP_old(add_xp);
	hero = Cast_PointerToInstance(placeholder);
	B_GivePlayerXP_old(add_xp);
};


//"Half XP-Share"-Hooks

/*
func void B_GivePlayerXP (var int add_xp)
{
	
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	B_GivePlayerXP_old(add_xp/2);
	hero = Cast_PointerToInstance(placeholder);
	B_GivePlayerXP_old(add_xp/2);
};
*/


//"Each player gets his own XP"-Hooks

/*
const int player_1_getsXP = 0;
const int player_2_getsXP = 0;

func void B_GivePlayerXP (var int add_xp)
{
	var int placeholder; placeholder = Cast_InstanceToPointer(hero);
	
	if (((Cast_InstanceToPointer(other) == Cast_InstanceToPointer(hero_2)) || (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero_2)))){
		player_2_getsXP = 1;
		hero = Cast_PointerToInstance(Cast_InstanceToPointer(hero_2));
	}else if (((Cast_InstanceToPointer(other) == Cast_InstanceToPointer(hero)) || (Cast_InstanceToPointer(self) == Cast_InstanceToPointer(hero)))){
		player_1_getsXP = 1;
	};
	
	B_GivePlayerXP_old(add_xp);
	
	hero = Cast_PointerToInstance(placeholder);
	player_1_getsXP = 0;
	player_2_getsXP = 0;
};
*/
